﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	
	Public const CALL_MODE_GET As  Int = 1
	Public const CALL_MODE_POST As Int = 2
	
	Public const REGISTRAZIONE_BUSINESS As   String = "BUSINESS"
	Public const REGISTRAZIONE_CONSUMER As   String = "CONSUMER"
	Public const CONTATORE_CONSUMERS_GET As  String = "CONSUMERS"
	Public const ELENCO_CONSUMERS_GET As     String = "CONSUMERS/"
	Public const ELENCO_ESERCENTI_GET As     String = "BUSINESSES"
	Public const ELENCO_ESERCENTI_POST As    String = "BUSINESSES"
	Public const ELENCO_INTERESSI As         String = "INTERESTS/"
	Public const ELENCO_PROMOZIONI As        String = "PROMOTIONS/"
	Public const ELENCO_PROFESSIONI As       String = "JOBS/"
	Public const RACCOLTA_PUNTI As           String = "POINTS"
	Public const MOVIMENTA_PUNTO As          String = "POINT"
	Public const ELENCO_PUNTI_MOVIMENTATI As String = "POINTS/"
	Public const ACQUISTA_PUNTI As           String = "POINTS/"
	Public const CONVERTI_PUNTI As           String = "POINTS"
	Public const INVIA_CAMPAGNA As           String = "PROMOTION"
	
	Private mHandler As Object
	Private mEventName As String = ""
	Private mFirm As String = ""
	Private SU As StringUtils
	Private BC As ByteConverter
	Private MD As MessageDigest
	Private EndPoint As String 	= "https://icommlab.com/app/icommlab/"
	Private mContentType As String = "application/json"
	Private mVars As Map
	Private mList As List
	Private LastCallType As Int = 0
	
End Sub

'Inizializza l'oggetto per il suo utilizzo
'pHandler = Oggetto che conterrà il raise degli eventi
'pEventName = Nome dell'evento
Public Sub Initialize(pHandler As Object, pEventName As String)
	
	mHandler = pHandler
	mEventName = pEventName
	mVars.Initialize
	mList.Initialize
	
End Sub

' Imposta il Content-Type (Default = application/json)
public Sub getContentType As String
	Return mContentType
End Sub

' Imposta il Content-Type (Default = application/json)
public Sub setContentType(v As String)
	mContentType = v
End Sub

' Chiama il Web Service con la Firma
' callMode (GET o POST)
' FunctionToCall (SELLER / MOBILE / ECC..ECC..)
public Sub CallFirmed(callMode As Int, FunctionToCall As String)
	Dim VarData As String = ""
	If callMode = CALL_MODE_GET Then
		VarData = VarToGET
	Else
		VarData = VarToJSON
	End If
	CallWS(callMode, FunctionToCall, True, VarData)
End Sub

' Chiama il Web Service senza la Firma
' callMode (GET o POST)
' FunctionToCall (SELLER / MOBILE / ECC..ECC..)
public Sub Call(callMode As Int, FunctionToCall As String)
	Dim VarData As String = ""
	If callMode = CALL_MODE_GET Then
		VarData = VarToGET
	Else
		VarData = VarToJSON
	End If
	CallWS(callMode, FunctionToCall, False, VarData)
End Sub

'Imposta la firma per la chiamata
' user_id = id utente o numero telefonico cliente finale
' payload = stringa JSON contenente i dati da trasferire
' TokenOrPassword = token di accesso o la password per la firma
public Sub SetFirm( user_id As String, payLoad As String, Token As String)
	
	Dim t As String = user_id & payLoad & Token
	Dim passwordhash() As Byte
	passwordhash = MD.GetMessageDigest(t.GetBytes("UTF8"),"MD5")
	Dim MD5 As String = BC.HexFromBytes(passwordhash).ToLowerCase
	Dim json As String = "{""suite_id"":" & user_id & ",""sign"":""" & MD5 & """}"
	mFirm = SU.EncodeBase64(BC.StringToBytes(json, "UTF8"))
	
End Sub

'Imposta la firma per la chiamata
' user_id = id utente o numero telefonico cliente finale
' payload = stringa JSON contenente i dati da trasferire
' TokenOrPassword = token di accesso o la password per la firma
public Sub SetFirstFirm( user_id As String, payLoad As String, Password As String)
	
	Dim t As String = user_id & payLoad
	Dim passwordhash() As Byte
	Dim psw2() As Byte
	passwordhash = MD.GetMessageDigest(Password.GetBytes("UTF8"),"MD5")
	Dim MD5Pwd As String = BC.HexFromBytes(passwordhash).ToLowerCase
	t = t & MD5Pwd
	psw2 = MD.GetMessageDigest(t.GetBytes("UTF8"),"MD5")
	Dim MD5 As String = BC.HexFromBytes(psw2).ToLowerCase
	Dim json As String = "{""user_id"":" & user_id & ",""sign"":""" & MD5 & """}"
	mFirm = SU.EncodeBase64(BC.StringToBytes(json, "UTF8"))
	
End Sub

' Aggiunge una mappa alla variabile specificata
' varname = nome della variabile
public Sub AddMap(varname As String) As Boolean
	Dim ok As Boolean = True
	Dim m As Map
	m.Initialize
	Try
		mVars.Put(varname, m)
	Catch
		ok = False
	End Try
	Return ok
End Sub

' Aggiunge una mappa alla mappa di variabile specificata
' rootvars = Array di livello della variabile di root che contiene la mappa
' varname = nome della variabile
public Sub AddMap2(rootvars() As String, varname As String)	As Boolean
	Dim ok As Boolean = False
	Dim m As Map = Null
	Dim u As Map = mVars
	
	For Each rootvar As String In rootvars
		m = u.Get(rootvar)
		If m = Null Then Exit
		u = m
	Next
	
	If m <> Null Then
		Dim mnew As Map
		mnew.Initialize
		Try
			m.Put(varname, mnew)
			ok = True
		Catch
			ok = False
		End Try
	End If
	
	Return ok
End Sub

' Aggiunge una variabile alla root del payload
' varname = Nome della variabile
' varvalue = Contenuto della variabile
public Sub AddVar(varname As String, varvalue As String) As Boolean
	Dim ok As Boolean = True
	Try
		mVars.Put(varname, varvalue)
	Catch
		ok = False
	End Try
	Return ok
End Sub

' Aggiunge una variabile alla mappa di variabile specificata 
' rootvars = Array di livello della variabile di root che contiene la mappa
' varname = Nome della variabile
' varvalue = Contenuto della variabile
public Sub AddVar2(rootvars() As String, varname As String, varvalue As String) As Boolean
	Dim ok As Boolean = False
	Dim m As Map = Null
	Dim u As Map = mVars
	For Each rootvar As String In rootvars
		m = u.Get(rootvar)
		If m = Null Then Exit
		u = m
	Next
	If m <> Null Then
		Try
			m.Put(varname, varvalue)
			ok = True
		Catch
			ok = False
		End Try
		
	End If
	Return ok
End Sub

public Sub SetList(l As List)
	mList = l
End Sub

public Sub SetVars(m As Map)
	mVars = m
End Sub

' Restituisce la stringa JSON (payload) in base alle variabili caricate
public Sub VarToJSON() As String
	Dim JSON As JSONGenerator
	If mList.IsInitialized = True And mList.Size > 0 Then
		JSON.Initialize2(mList)
	Else
		JSON.Initialize(mVars)
	End If
	Return JSON.ToString()
End Sub

public Sub VarToGET() As String
	
	Dim sRet As String = ""
	For Each k As String In mVars.Keys
		If sRet <> "" Then sRet = sRet & "&"
		sRet = sRet & k & "=" & mVars.Get(k)
	Next
	
	If sRet <> "" Then Return "?" & sRet
	
	Return ""
	
End Sub

private Sub CallWS(callMode As Int, WSName As String, Firmed As Boolean, JSONData As String)
	
	LastCallType = callMode
	
	Dim j As MyHttpJob
	j.Initialize(WSName, Me)
	Dim BC As ByteConverter
	Dim Data() As Byte = BC.StringToBytes(JSONData, "utf-8")
	If callMode = CALL_MODE_POST Then
		j.HttpClientParams.Put("http.protocol.expect-continue", False)
		j.PostBytes(EndPoint & WSName, Data)
	Else
		j.Download(EndPoint & WSName & JSONData)
	End If
	Dim httprequest As HttpRequest = j.GetRequest
	httprequest.Timeout = 25000
	httprequest.SetHeader("Content-Type", mContentType & ";charset=utf-8")
	'j.GetRequest.SetContentType(mContentType)
	'j.GetRequest.SetContentEncoding("UTF-8")
	If Firmed = True Then
		httprequest.SetHeader("Authorization", "Bearer " & mFirm)
		If callMode = CALL_MODE_POST Then
			
		End If
	End If
	
	' Azzera le variabili impostate in precedenza
	If mVars.IsInitialized = True Then mVars.Clear
	mVars.Initialize
	
	If mList.IsInitialized = True Then mList.Clear
	mList.Initialize
	
	
	
End Sub

Private Sub JobDone(j As MyHttpJob)
	
	Dim ResponseWS As String = ""
	Dim WSName As String  = j.JobName

	If j.Success Then
		
		ResponseWS = SU.DecodeUrl(j.GetString2("utf-8"), "utf-8")
		
		WSDone(WSName, ResponseWS)
		
		'If SubExists(mHandler, mEventName & "_Done") Then
		'	CallSub3(mHandler, mEventName & "_Done", j.JobName, ResponseWS)
		'End If
		
	Else
		' Segnalare l'errore
		Log("Errore " & j.ErrorMessage)
		
		WsError(WSName, j.ErrorMessage)
				
		'If SubExists(mHandler, mEventName & "_Error") Then
		'	CallSub3(mHandler, mEventName & "_Error", j.JobName, j.ErrorMessage)
		'End If
		
	End If
	
	j.HttpClientParams.Clear
	j.Release
	
End Sub

private Sub WSDone(WSName As String, ResponseWS As String)
	Dim JS As JSONParser
	Dim oRet As String
	
	oRet = "OK"

	If SubExists(mHandler, mEventName & "_Done") Then
		CallSub3(mHandler, mEventName & "_Done", WSName, oRet)
	End If
	
End Sub

private Sub WsError(WSName As String, ResponseWS As String)
	Dim oRet As String
	oRet = ResponseWS
	
	If SubExists(mHandler, mEventName & "_Error") Then
		CallSub3(mHandler, mEventName & "_Error", WSName, oRet)
	End If

End Sub

